---
title: FileSystemDirectoryHandle.getDirectoryHandle()
slug: Web/API/FileSystemDirectoryHandle/getDirectoryHandle
tags:
  - Directories
  - Directory
  - File
  - File System Access API
  - FileSystemDirectoryHandle
  - Method
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>getDirectoryHandle()</code></strong> method of the {{domxref("FileSystemDirectoryHandle")}} interface returns a {{domxref('FileSystemDirectoryHandle')}} for a subdirectory with the specified name within the directory handle on which the method is called.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>FileSystemDirectoryHandle</var> = FileSystemDirectoryHandle.getDirectoryHandle();</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>name</em></dt>
 <dd>A {{domxref('USVString')}} representing the {{domxref('FileSystemHandle.name')}} of the subdirectory you wish to retrieve.</dd>
 <dt><em>options</em> {{optional_inline}}</dt>
 <dd>An optional object containing options for the retrieved subdirectory. Options are as follows:
 <ul>
  <li><code>create</code>: A {{jsxref('Boolean')}}. Default <code>false</code>. When set to <code>true</code> if the directory is not found, one with the specified name will be created and returned.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} which resolves with a {{domxref('FileSystemDirectoryHandle')}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>NotAllowedError</code></dt>
 <dd>If {{domxref('PermissionStatus')}} is not 'granted'.</dd>
 <dt><code>TypeMismatchError</code></dt>
 <dd>If the returned entry is a file and not a directory.</dd>
 <dt><code>NotFoundError</code></dt>
 <dd>if directory doesn't exist and the <code>create</code> option is set to <code>false</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example returns a directory handle with the specified name, if the directory does not exist it is created.</p>

<pre class="brush: js notranslate">const dirName = 'directoryToGetName';

// assuming we have a directory handle: 'currentDirHandle'
const subDir = currentDirHandle.getDirectoryHandle(dirName, {create: true});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access API','#dom-filesystemdirectoryhandle-getdirectoryhandle','getDirectoryHandle')}}</td>
   <td>{{Spec2('File System Access API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemDirectoryHandle.getDirectoryHandle")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
